/*
 * Menu.java
 *
 * Created on 23 July 2007, 22:38
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package assignment;

import java.lang.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.prefs.*;
import java.util.HashMap;

/**
 *
 * @author David
 */
public class Menu extends JMenuBar {
    
    String[ ] fileItems = new String[ ] { "New", "Open...", "Save", "Save As...", "Exit" };
    String[ ] editItems = new String[ ] { "Compose with...", "Parallel Reach..." };
    String[ ] viewItems = new String[ ] { "Refresh", "Sim Iterate", "Reset Layout"};
    String[ ] toolItems = new String[ ] { "Select", "Move Node", "Set Start Node", 
        "Add Transition", "Add Node", 
        "Remove Transition", "Remove Node" };
    String[ ] helpItems = new String[ ] { "Help", "About" };
    
    MainWindow mainApp;
    /** Creates a new instance of Menu */
    public Menu(MainWindow theMain, Preferences prefs) {
        //@TODO: Implement shortcut keys
        mainApp = theMain;
        JMenu fileMenu = new JMenu("File");
        JMenu editMenu = new JMenu("Edit");
        JMenu viewMenu = new JMenu("View");
        JMenu toolMenu = new JMenu("Tools");
        JMenu helpMenu = new JMenu("Help");
        
        // Handle the recent files list:
        /*ActionListener openListener = new ActionListener(  ) {
         public void actionPerformed(ActionEvent event) {
             mainApp.handleOpenEvent(event.getActionCommand());
            //System.out.println("Menu item [" + event.getActionCommand(  ) + "] was pressed.");
         }
        };*/
        JMenu recentFiles = new JMenu("Recent Files");
        /*Preferences prf = prefs.node("recentFiles");
        
        try {
            prf.flush();
        } catch (Exception e) {};
        
        String[] recentFileList = null;
        try {
            recentFileList = prf.childrenNames();
            if (recentFileList.length == 0)
                System.out.println("Recent file list empty");
            else
                System.out.println("Recent Files List Loaded.");
        } catch (Exception e) {
            System.out.println("ERROR: " + e.toString());
            System.out.println("Recent files list not available");
        }
        if (recentFileList != null)
            for (String s:recentFileList) {
                JMenuItem item = new JMenuItem(s);
                item.setActionCommand(prf.get(s,"ERROR"));
                item.addActionListener(openListener);
                recentFiles.add(item);
            }
        */

        
        // A standard menu action listener
        ActionListener printListener = new ActionListener(  ) {
         public void actionPerformed(ActionEvent event) {
             mainApp.handleMenuEvent(event.getActionCommand());
            //System.out.println("Menu item [" + event.getActionCommand(  ) + "] was pressed.");
         }
        };
        
        // An action listener for the tools menu:
        ActionListener toolListener = new ActionListener(  ) {
         public void actionPerformed(ActionEvent event) {
             mainApp.switchTool(event.getActionCommand());
         }
        };
        
        // Assemble the File menu...
        setupMenu(fileItems, fileMenu, printListener);       
        
        // And the edit menu...
        setupMenu(editItems, editMenu, printListener);
        
        // The view menu...
        HashMap<Integer, KeyStroke> shortcuts = new HashMap<Integer, KeyStroke>();
        shortcuts.put(0,KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0, false));
        shortcuts.put(1,KeyStroke.getKeyStroke(KeyEvent.VK_F6, 0, false));
        setupMenu(viewItems, viewMenu, printListener, shortcuts);
        
        // The edit menu...
        setupMenu(toolItems, toolMenu, toolListener);
        
        // The help menu...
        setupMenu(helpItems, helpMenu, printListener);
        
        add(fileMenu);
        add(editMenu);
        add(viewMenu);
        add(toolMenu);
        //add(helpMenu);
    }
    
    /** This constructs adds a list of strings to a JMenu using a specified actionListener
     */
    protected void setupMenu(String [ ] menuItems, JMenu theMenu, ActionListener act) {
        for (int i=0; i < menuItems.length; i++) {
            JMenuItem item = new JMenuItem(menuItems[i]);
            item.addActionListener(act);
            theMenu.add(item);
        }
    }
   
    /** Does the same as the other setupMenu function except with support for shortcut
     *  keys.
     */
    protected void setupMenu(   String [ ] menuItems, 
                                JMenu theMenu, 
                                ActionListener act, 
                                HashMap<Integer, KeyStroke> shortcutKeys) {
        for (int i=0; i < menuItems.length; i++) {
            JMenuItem item = new JMenuItem(menuItems[i]);
            item.addActionListener(act);
            
            // Setup the shortcut keys:
            if (shortcutKeys.containsKey(i))
                item.setAccelerator(shortcutKeys.get(i));
            
            theMenu.add(item);
        }
    }
    
}
